package KCSoft.ScrollViewBigPanel;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "KCSoft.ScrollViewBigPanel", "KCSoft.ScrollViewBigPanel.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "KCSoft.ScrollViewBigPanel", "KCSoft.ScrollViewBigPanel.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "KCSoft.ScrollViewBigPanel.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _maintimer = null;
public static byte _lightofflogicf = (byte)0;
public static byte _connectedf = (byte)0;
public anywheresoftware.b4a.objects.SwitchWrapper _switch1 = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvtest = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnltest = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnconnect = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmessage = null;
public anywheresoftware.b4a.objects.ProgressBarWrapper _progressbar1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _lightoffdelay = null;
public anywheresoftware.b4a.objects.SwitchWrapper _lightofflogic = null;
public anywheresoftware.b4a.objects.EditTextWrapper _lightondly = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbllightoffdelay = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbllightofflogic = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbllightondly = null;
public anywheresoftware.b4a.objects.ButtonWrapper _transmit = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblstatus = null;
public anywheresoftware.b4a.objects.EditTextWrapper _volagecal = null;
public KCSoft.ScrollViewBigPanel.starter _starter = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="scvTest.Panel.LoadLayout(\"PoolTIME\")";
mostCurrent._scvtest.getPanel().LoadLayout("PoolTIME",mostCurrent.activityBA);
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="scvTest.Panel.Height = pnlTest.Height";
mostCurrent._scvtest.getPanel().setHeight(mostCurrent._pnltest.getHeight());
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="MainTimer.Initialize(\"MainTimer\", 1000)";
_maintimer.Initialize(processBA,"MainTimer",(long) (1000));
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="MainTimer.Enabled = True";
_maintimer.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _btnconnect_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "btnconnect_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnconnect_click", null);
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub btnConnect_Click";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="CallSub(Starter, \"Connect\")";
anywheresoftware.b4a.keywords.Common.CallSubDebug(processBA,(Object)(mostCurrent._starter.getObject()),"Connect");
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="ConnectedF=1";
_connectedf = (byte) (1);
RDebugUtils.currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="End Sub";
return "";
}
public static String  _edtitem_focuschanged(boolean _hasfocus) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "edtitem_focuschanged"))
	return (String) Debug.delegate(mostCurrent.activityBA, "edtitem_focuschanged", new Object[] {_hasfocus});
anywheresoftware.b4a.objects.EditTextWrapper _send = null;
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub edtItem_FocusChanged (HasFocus As Boolean)";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Dim Send As EditText";
_send = new anywheresoftware.b4a.objects.EditTextWrapper();
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="If HasFocus Then";
if (_hasfocus) { 
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="Send = Sender";
_send.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="scvTest.ScrollPosition = Send.Top - 10dip";
mostCurrent._scvtest.setScrollPosition((int) (_send.getTop()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))));
 };
RDebugUtils.currentLine=327688;
 //BA.debugLineNum = 327688;BA.debugLine="End Sub";
return "";
}
public static String  _lightofflogic_checkedchange(boolean _checked) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "lightofflogic_checkedchange"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lightofflogic_checkedchange", new Object[] {_checked});
byte _b = (byte)0;
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub LightOffLogic_CheckedChange(Checked As Boolean";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="Dim b As Byte";
_b = (byte)0;
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="If Checked Then";
if (_checked) { 
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="LightOffLogicF = 1";
_lightofflogicf = (byte) (1);
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="LblLightOffLogic.Text=\"On time duration setup\"";
mostCurrent._lbllightofflogic.setText(BA.ObjectToCharSequence("On time duration setup"));
 }else {
RDebugUtils.currentLine=458758;
 //BA.debugLineNum = 458758;BA.debugLine="LightOffLogicF = 0";
_lightofflogicf = (byte) (0);
RDebugUtils.currentLine=458759;
 //BA.debugLineNum = 458759;BA.debugLine="LblLightOffLogic.Text=\"Off time before sunset\"";
mostCurrent._lbllightofflogic.setText(BA.ObjectToCharSequence("Off time before sunset"));
 };
RDebugUtils.currentLine=458762;
 //BA.debugLineNum = 458762;BA.debugLine="End Sub";
return "";
}
public static String  _maintimer_tick() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "maintimer_tick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "maintimer_tick", null);
byte[] _txbuff = null;
byte[] _rxbuff = null;
String _strbuff = "";
byte _cs = (byte)0;
byte _c = (byte)0;
byte _p = (byte)0;
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub MainTimer_Tick";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="Dim TxBuff(50) As Byte";
_txbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="Dim RxBuff(50) As Byte";
_rxbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="Dim StrBuff As String";
_strbuff = "";
RDebugUtils.currentLine=917508;
 //BA.debugLineNum = 917508;BA.debugLine="Dim Cs, c, p As Byte";
_cs = (byte)0;
_c = (byte)0;
_p = (byte)0;
RDebugUtils.currentLine=917510;
 //BA.debugLineNum = 917510;BA.debugLine="StrBuff=Sprintf (\"XPXXZZS%s\", Array As Object( Vo";
_strbuff = _sprintf("XPXXZZS%s",new Object[]{(Object)(mostCurrent._volagecal.getText())});
RDebugUtils.currentLine=917511;
 //BA.debugLineNum = 917511;BA.debugLine="TxBuff = StrBuff.GetBytes(\"UTF8\")";
_txbuff = _strbuff.getBytes("UTF8");
RDebugUtils.currentLine=917512;
 //BA.debugLineNum = 917512;BA.debugLine="TxBuff(0)=2";
_txbuff[(int) (0)] = (byte) (2);
RDebugUtils.currentLine=917513;
 //BA.debugLineNum = 917513;BA.debugLine="TxBuff(5)=5";
_txbuff[(int) (5)] = (byte) (5);
RDebugUtils.currentLine=917514;
 //BA.debugLineNum = 917514;BA.debugLine="If ConnectedF=1 Then";
if (_connectedf==1) { 
RDebugUtils.currentLine=917515;
 //BA.debugLineNum = 917515;BA.debugLine="CallSub2(Starter, \"SendMessage\", TxBuff)";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_txbuff));
RDebugUtils.currentLine=917516;
 //BA.debugLineNum = 917516;BA.debugLine="CallSub2(Starter, \"SendMessage\", Array As Byte(3";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(new byte[]{(byte) (3),(byte) (4)}));
 }else {
RDebugUtils.currentLine=917518;
 //BA.debugLineNum = 917518;BA.debugLine="lblStatus.Text=\"Not connected\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Not connected"));
 };
RDebugUtils.currentLine=917520;
 //BA.debugLineNum = 917520;BA.debugLine="End Sub";
return "";
}
public static String  _sprintf(String _fmt,Object[] _arg) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "sprintf"))
	return (String) Debug.delegate(mostCurrent.activityBA, "sprintf", new Object[] {_fmt,_arg});
int _ai = 0;
int _fi = 0;
int _i = 0;
int _j = 0;
int _exp = 0;
int _wid = 0;
String _stmp = "";
String _ptmp = "";
String _sres = "";
String _c = "";
String _s = "";
String _t = "";
boolean _bdone = false;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub Sprintf(fmt As String, arg() As Object) As Str";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Dim ai, fi, i, j As Int";
_ai = 0;
_fi = 0;
_i = 0;
_j = 0;
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Dim exp, wid As Int";
_exp = 0;
_wid = 0;
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="Dim stmp, ptmp, sres, c, s, t As String";
_stmp = "";
_ptmp = "";
_sres = "";
_c = "";
_s = "";
_t = "";
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="Dim bdone As Boolean";
_bdone = false;
RDebugUtils.currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="ai = 0";
_ai = (int) (0);
RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="fi = 0";
_fi = (int) (0);
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="stmp = \"\"";
_stmp = "";
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="sres = \"\"";
_sres = "";
RDebugUtils.currentLine=393227;
 //BA.debugLineNum = 393227;BA.debugLine="Do While (fi < fmt.Length)";
while ((_fi<_fmt.length())) {
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="c = fmt.CharAt(fi)";
_c = BA.ObjectToString(_fmt.charAt(_fi));
RDebugUtils.currentLine=393229;
 //BA.debugLineNum = 393229;BA.debugLine="fi = fi + 1";
_fi = (int) (_fi+1);
RDebugUtils.currentLine=393231;
 //BA.debugLineNum = 393231;BA.debugLine="If (c = \"%\") Then";
if (((_c).equals("%"))) { 
RDebugUtils.currentLine=393232;
 //BA.debugLineNum = 393232;BA.debugLine="stmp = \"\"";
_stmp = "";
RDebugUtils.currentLine=393233;
 //BA.debugLineNum = 393233;BA.debugLine="ptmp = \"\"";
_ptmp = "";
RDebugUtils.currentLine=393234;
 //BA.debugLineNum = 393234;BA.debugLine="bdone = False";
_bdone = anywheresoftware.b4a.keywords.Common.False;
RDebugUtils.currentLine=393236;
 //BA.debugLineNum = 393236;BA.debugLine="Do While ((fi < fmt.Length) And (bdone = False)";
while (((_fi<_fmt.length()) && (_bdone==anywheresoftware.b4a.keywords.Common.False))) {
RDebugUtils.currentLine=393237;
 //BA.debugLineNum = 393237;BA.debugLine="c = fmt.CharAt(fi)";
_c = BA.ObjectToString(_fmt.charAt(_fi));
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="fi = fi + 1";
_fi = (int) (_fi+1);
RDebugUtils.currentLine=393240;
 //BA.debugLineNum = 393240;BA.debugLine="If ((IsNumber(c) = True) Or (c = \".\")) Then";
if (((anywheresoftware.b4a.keywords.Common.IsNumber(_c)==anywheresoftware.b4a.keywords.Common.True) || ((_c).equals(".")))) { 
RDebugUtils.currentLine=393241;
 //BA.debugLineNum = 393241;BA.debugLine="ptmp = ptmp & c";
_ptmp = _ptmp+_c;
RDebugUtils.currentLine=393242;
 //BA.debugLineNum = 393242;BA.debugLine="bdone = False";
_bdone = anywheresoftware.b4a.keywords.Common.False;
 }else 
{RDebugUtils.currentLine=393243;
 //BA.debugLineNum = 393243;BA.debugLine="Else If (c = \"s\") Then";
if (((_c).equals("s"))) { 
RDebugUtils.currentLine=393244;
 //BA.debugLineNum = 393244;BA.debugLine="stmp = arg(ai)";
_stmp = BA.ObjectToString(_arg[_ai]);
RDebugUtils.currentLine=393245;
 //BA.debugLineNum = 393245;BA.debugLine="ai = ai + 1";
_ai = (int) (_ai+1);
RDebugUtils.currentLine=393246;
 //BA.debugLineNum = 393246;BA.debugLine="sres = sres & stmp";
_sres = _sres+_stmp;
RDebugUtils.currentLine=393247;
 //BA.debugLineNum = 393247;BA.debugLine="bdone = True";
_bdone = anywheresoftware.b4a.keywords.Common.True;
 }else 
{RDebugUtils.currentLine=393248;
 //BA.debugLineNum = 393248;BA.debugLine="Else If (c = \"d\") Then";
if (((_c).equals("d"))) { 
RDebugUtils.currentLine=393249;
 //BA.debugLineNum = 393249;BA.debugLine="If (ptmp.Length > 0) Then";
if ((_ptmp.length()>0)) { 
RDebugUtils.currentLine=393250;
 //BA.debugLineNum = 393250;BA.debugLine="t = \" \"";
_t = " ";
RDebugUtils.currentLine=393251;
 //BA.debugLineNum = 393251;BA.debugLine="If (ptmp.CharAt(0) = \"0\") Then";
if ((_ptmp.charAt((int) (0))==BA.ObjectToChar("0"))) { 
RDebugUtils.currentLine=393252;
 //BA.debugLineNum = 393252;BA.debugLine="t = \"0\"";
_t = "0";
RDebugUtils.currentLine=393253;
 //BA.debugLineNum = 393253;BA.debugLine="ptmp = ptmp.SubString(1)";
_ptmp = _ptmp.substring((int) (1));
 };
 };
RDebugUtils.currentLine=393257;
 //BA.debugLineNum = 393257;BA.debugLine="If (ptmp.Length > 0) Then wid = ptmp Else wid";
if ((_ptmp.length()>0)) { 
_wid = (int)(Double.parseDouble(_ptmp));}
else {
_wid = (int) (0);};
RDebugUtils.currentLine=393259;
 //BA.debugLineNum = 393259;BA.debugLine="stmp = arg(ai)";
_stmp = BA.ObjectToString(_arg[_ai]);
RDebugUtils.currentLine=393261;
 //BA.debugLineNum = 393261;BA.debugLine="Do While (stmp.Length < wid)";
while ((_stmp.length()<_wid)) {
RDebugUtils.currentLine=393262;
 //BA.debugLineNum = 393262;BA.debugLine="stmp = t & stmp";
_stmp = _t+_stmp;
 }
;
RDebugUtils.currentLine=393265;
 //BA.debugLineNum = 393265;BA.debugLine="ai = ai + 1";
_ai = (int) (_ai+1);
RDebugUtils.currentLine=393266;
 //BA.debugLineNum = 393266;BA.debugLine="sres = sres & stmp";
_sres = _sres+_stmp;
RDebugUtils.currentLine=393267;
 //BA.debugLineNum = 393267;BA.debugLine="bdone = True";
_bdone = anywheresoftware.b4a.keywords.Common.True;
 }else 
{RDebugUtils.currentLine=393268;
 //BA.debugLineNum = 393268;BA.debugLine="Else If (c = \"f\") Then";
if (((_c).equals("f"))) { 
RDebugUtils.currentLine=393269;
 //BA.debugLineNum = 393269;BA.debugLine="If (ptmp.Length > 0) Then";
if ((_ptmp.length()>0)) { 
RDebugUtils.currentLine=393270;
 //BA.debugLineNum = 393270;BA.debugLine="i = ptmp.IndexOf(\".\")";
_i = _ptmp.indexOf(".");
RDebugUtils.currentLine=393271;
 //BA.debugLineNum = 393271;BA.debugLine="If (i >= 0) Then";
if ((_i>=0)) { 
RDebugUtils.currentLine=393272;
 //BA.debugLineNum = 393272;BA.debugLine="wid = ptmp.SubString2(0, i)";
_wid = (int)(Double.parseDouble(_ptmp.substring((int) (0),_i)));
RDebugUtils.currentLine=393273;
 //BA.debugLineNum = 393273;BA.debugLine="exp = ptmp.SubString(i+1)";
_exp = (int)(Double.parseDouble(_ptmp.substring((int) (_i+1))));
 }else {
RDebugUtils.currentLine=393275;
 //BA.debugLineNum = 393275;BA.debugLine="wid = ptmp";
_wid = (int)(Double.parseDouble(_ptmp));
RDebugUtils.currentLine=393276;
 //BA.debugLineNum = 393276;BA.debugLine="exp = 0";
_exp = (int) (0);
 };
RDebugUtils.currentLine=393279;
 //BA.debugLineNum = 393279;BA.debugLine="stmp = NumberFormat(arg(ai), wid, exp)";
_stmp = anywheresoftware.b4a.keywords.Common.NumberFormat((double)(BA.ObjectToNumber(_arg[_ai])),_wid,_exp);
 }else {
RDebugUtils.currentLine=393281;
 //BA.debugLineNum = 393281;BA.debugLine="stmp = arg(ai)";
_stmp = BA.ObjectToString(_arg[_ai]);
 };
RDebugUtils.currentLine=393284;
 //BA.debugLineNum = 393284;BA.debugLine="ai = ai + 1";
_ai = (int) (_ai+1);
RDebugUtils.currentLine=393285;
 //BA.debugLineNum = 393285;BA.debugLine="sres = sres & stmp";
_sres = _sres+_stmp;
RDebugUtils.currentLine=393286;
 //BA.debugLineNum = 393286;BA.debugLine="bdone = True";
_bdone = anywheresoftware.b4a.keywords.Common.True;
 }else {
RDebugUtils.currentLine=393288;
 //BA.debugLineNum = 393288;BA.debugLine="ai = ai + 1";
_ai = (int) (_ai+1);
 }}}}
;
 }
;
 }else {
RDebugUtils.currentLine=393293;
 //BA.debugLineNum = 393293;BA.debugLine="sres = sres & c";
_sres = _sres+_c;
 };
 }
;
RDebugUtils.currentLine=393297;
 //BA.debugLineNum = 393297;BA.debugLine="Return(sres)";
if (true) return (_sres);
RDebugUtils.currentLine=393298;
 //BA.debugLineNum = 393298;BA.debugLine="End Sub";
return "";
}
public static String  _messagefromdevice(String _msg) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "messagefromdevice"))
	return (String) Debug.delegate(mostCurrent.activityBA, "messagefromdevice", new Object[] {_msg});
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Public Sub MessageFromDevice(msg As String)";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="lblMessage.Text = msg";
mostCurrent._lblmessage.setText(BA.ObjectToCharSequence(_msg));
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="End Sub";
return "";
}
public static String  _setstate() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "setstate"))
	return (String) Debug.delegate(mostCurrent.activityBA, "setstate", null);
String _status = "";
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Public Sub SetState";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="Switch1.Enabled = Starter.connected";
mostCurrent._switch1.setEnabled(mostCurrent._starter._connected);
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="btnConnect.Enabled = Not(Starter.connected)";
mostCurrent._btnconnect.setEnabled(anywheresoftware.b4a.keywords.Common.Not(mostCurrent._starter._connected));
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="ProgressBar1.Visible = Starter.connecting";
mostCurrent._progressbar1.setVisible(mostCurrent._starter._connecting);
RDebugUtils.currentLine=524292;
 //BA.debugLineNum = 524292;BA.debugLine="Dim Status As String";
_status = "";
RDebugUtils.currentLine=524293;
 //BA.debugLineNum = 524293;BA.debugLine="If Starter.connected Then";
if (mostCurrent._starter._connected) { 
RDebugUtils.currentLine=524294;
 //BA.debugLineNum = 524294;BA.debugLine="Status = \"connected\"";
_status = "connected";
 }else 
{RDebugUtils.currentLine=524295;
 //BA.debugLineNum = 524295;BA.debugLine="else if Starter.connecting Then";
if (mostCurrent._starter._connecting) { 
RDebugUtils.currentLine=524296;
 //BA.debugLineNum = 524296;BA.debugLine="Status = \"trying to connect...\"";
_status = "trying to connect...";
 }else {
RDebugUtils.currentLine=524298;
 //BA.debugLineNum = 524298;BA.debugLine="Status = \"disconnected\"";
_status = "disconnected";
 }}
;
RDebugUtils.currentLine=524300;
 //BA.debugLineNum = 524300;BA.debugLine="lblStatus.Text = $\"Status: ${Status}\"$";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence(("Status: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_status))+"")));
RDebugUtils.currentLine=524301;
 //BA.debugLineNum = 524301;BA.debugLine="End Sub";
return "";
}
public static String  _switch1_checkedchange(boolean _checked) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "switch1_checkedchange"))
	return (String) Debug.delegate(mostCurrent.activityBA, "switch1_checkedchange", new Object[] {_checked});
byte _b = (byte)0;
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub Switch1_CheckedChange(Checked As Boolean)";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="Dim b As Byte";
_b = (byte)0;
RDebugUtils.currentLine=655362;
 //BA.debugLineNum = 655362;BA.debugLine="If Checked Then b = 49 Else b = 48";
if (_checked) { 
_b = (byte) (49);}
else {
_b = (byte) (48);};
RDebugUtils.currentLine=655364;
 //BA.debugLineNum = 655364;BA.debugLine="End Sub";
return "";
}
public static String  _transmit_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "transmit_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "transmit_click", null);
byte[] _txbuff = null;
byte[] _rxbuff = null;
String _strbuff = "";
byte _cs = (byte)0;
byte _c = (byte)0;
byte _p = (byte)0;
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub Transmit_Click";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="Dim TxBuff(50) As Byte";
_txbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="Dim RxBuff(50) As Byte";
_rxbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=851971;
 //BA.debugLineNum = 851971;BA.debugLine="Dim StrBuff As String";
_strbuff = "";
RDebugUtils.currentLine=851972;
 //BA.debugLineNum = 851972;BA.debugLine="Dim Cs, c, p As Byte";
_cs = (byte)0;
_c = (byte)0;
_p = (byte)0;
RDebugUtils.currentLine=851974;
 //BA.debugLineNum = 851974;BA.debugLine="StrBuff=Sprintf (\"XPXXZZS%s\", Array As Object( Vo";
_strbuff = _sprintf("XPXXZZS%s",new Object[]{(Object)(mostCurrent._volagecal.getText())});
RDebugUtils.currentLine=851975;
 //BA.debugLineNum = 851975;BA.debugLine="TxBuff = StrBuff.GetBytes(\"UTF8\")";
_txbuff = _strbuff.getBytes("UTF8");
RDebugUtils.currentLine=851976;
 //BA.debugLineNum = 851976;BA.debugLine="TxBuff(0)=2";
_txbuff[(int) (0)] = (byte) (2);
RDebugUtils.currentLine=851977;
 //BA.debugLineNum = 851977;BA.debugLine="TxBuff(5)=5";
_txbuff[(int) (5)] = (byte) (5);
RDebugUtils.currentLine=851978;
 //BA.debugLineNum = 851978;BA.debugLine="If ConnectedF=1 Then";
if (_connectedf==1) { 
RDebugUtils.currentLine=851979;
 //BA.debugLineNum = 851979;BA.debugLine="CallSub2(Starter, \"SendMessage\", TxBuff)";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_txbuff));
RDebugUtils.currentLine=851980;
 //BA.debugLineNum = 851980;BA.debugLine="CallSub2(Starter, \"SendMessage\", Array As Byte(3";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(new byte[]{(byte) (3),(byte) (4)}));
 }else {
RDebugUtils.currentLine=851982;
 //BA.debugLineNum = 851982;BA.debugLine="lblStatus.Text=\"Not connected\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Not connected"));
 };
RDebugUtils.currentLine=851984;
 //BA.debugLineNum = 851984;BA.debugLine="End Sub";
return "";
}
public static String  _txdata(byte _bt) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "txdata"))
	return (String) Debug.delegate(mostCurrent.activityBA, "txdata", new Object[] {_bt});
byte[] _txbuff = null;
byte[] _rxbuff = null;
String _strbuff = "";
byte _cs = (byte)0;
byte _c = (byte)0;
byte _p = (byte)0;
RDebugUtils.currentLine=2686976;
 //BA.debugLineNum = 2686976;BA.debugLine="Sub TxData (Bt As Byte)";
RDebugUtils.currentLine=2686977;
 //BA.debugLineNum = 2686977;BA.debugLine="Dim TxBuff(50) As Byte";
_txbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=2686978;
 //BA.debugLineNum = 2686978;BA.debugLine="Dim RxBuff(50) As Byte";
_rxbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=2686979;
 //BA.debugLineNum = 2686979;BA.debugLine="Dim StrBuff As String";
_strbuff = "";
RDebugUtils.currentLine=2686980;
 //BA.debugLineNum = 2686980;BA.debugLine="Dim Cs, c, p As Byte";
_cs = (byte)0;
_c = (byte)0;
_p = (byte)0;
RDebugUtils.currentLine=2686982;
 //BA.debugLineNum = 2686982;BA.debugLine="StrBuff=Sprintf (\"XPXXZZS%s\", Array As Object( Vo";
_strbuff = _sprintf("XPXXZZS%s",new Object[]{(Object)(mostCurrent._volagecal.getText())});
RDebugUtils.currentLine=2686983;
 //BA.debugLineNum = 2686983;BA.debugLine="TxBuff = StrBuff.GetBytes(\"UTF8\")";
_txbuff = _strbuff.getBytes("UTF8");
RDebugUtils.currentLine=2686984;
 //BA.debugLineNum = 2686984;BA.debugLine="TxBuff(0)=2";
_txbuff[(int) (0)] = (byte) (2);
RDebugUtils.currentLine=2686985;
 //BA.debugLineNum = 2686985;BA.debugLine="TxBuff(5)=5";
_txbuff[(int) (5)] = (byte) (5);
RDebugUtils.currentLine=2686986;
 //BA.debugLineNum = 2686986;BA.debugLine="CallSub2(Starter, \"SendMessage\", TxBuff)";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_txbuff));
RDebugUtils.currentLine=2686987;
 //BA.debugLineNum = 2686987;BA.debugLine="CallSub2(Starter, \"SendMessage\", Array As Byte(3,";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(new byte[]{(byte) (3),(byte) (4)}));
RDebugUtils.currentLine=2686988;
 //BA.debugLineNum = 2686988;BA.debugLine="End Sub";
return "";
}
public static String  _volagecal_focuschanged(boolean _hasfocus) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "volagecal_focuschanged"))
	return (String) Debug.delegate(mostCurrent.activityBA, "volagecal_focuschanged", new Object[] {_hasfocus});
byte[] _txbuff = null;
byte[] _rxbuff = null;
String _strbuff = "";
byte _cs = (byte)0;
byte _c = (byte)0;
byte _p = (byte)0;
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub VolageCal_FocusChanged (HasFocus As Boolean)";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="Dim TxBuff(50) As Byte";
_txbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="Dim RxBuff(50) As Byte";
_rxbuff = new byte[(int) (50)];
;
RDebugUtils.currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="Dim StrBuff As String";
_strbuff = "";
RDebugUtils.currentLine=786436;
 //BA.debugLineNum = 786436;BA.debugLine="Dim Cs, c, p As Byte";
_cs = (byte)0;
_c = (byte)0;
_p = (byte)0;
RDebugUtils.currentLine=786438;
 //BA.debugLineNum = 786438;BA.debugLine="If HasFocus=False Then";
if (_hasfocus==anywheresoftware.b4a.keywords.Common.False) { 
RDebugUtils.currentLine=786439;
 //BA.debugLineNum = 786439;BA.debugLine="StrBuff=Sprintf (\"XPXXZZS%s\", Array As Object( V";
_strbuff = _sprintf("XPXXZZS%s",new Object[]{(Object)(mostCurrent._volagecal.getText())});
RDebugUtils.currentLine=786440;
 //BA.debugLineNum = 786440;BA.debugLine="TxBuff = StrBuff.GetBytes(\"UTF8\")";
_txbuff = _strbuff.getBytes("UTF8");
RDebugUtils.currentLine=786441;
 //BA.debugLineNum = 786441;BA.debugLine="TxBuff(0)=2";
_txbuff[(int) (0)] = (byte) (2);
RDebugUtils.currentLine=786442;
 //BA.debugLineNum = 786442;BA.debugLine="TxBuff(5)=5";
_txbuff[(int) (5)] = (byte) (5);
RDebugUtils.currentLine=786443;
 //BA.debugLineNum = 786443;BA.debugLine="If ConnectedF=1 Then";
if (_connectedf==1) { 
RDebugUtils.currentLine=786444;
 //BA.debugLineNum = 786444;BA.debugLine="CallSub2(Starter, \"SendMessage\", TxBuff)";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_txbuff));
RDebugUtils.currentLine=786445;
 //BA.debugLineNum = 786445;BA.debugLine="CallSub2(Starter, \"SendMessage\", Array As Byte(";
anywheresoftware.b4a.keywords.Common.CallSubDebug2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(new byte[]{(byte) (3),(byte) (4)}));
 }else {
RDebugUtils.currentLine=786447;
 //BA.debugLineNum = 786447;BA.debugLine="lblStatus.Text=\"Not connected\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Not connected"));
 };
 };
RDebugUtils.currentLine=786450;
 //BA.debugLineNum = 786450;BA.debugLine="End Sub";
return "";
}
}